#include "zxmain.h"
#include "ui_zxmain.h"
#include <QMessageBox>

zxMain::zxMain(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::zxMain)
{
    ui->setupUi(this);    
    this->setFixedWidth(400);
    this->setFixedHeight(400);
    m_manager=new QNetworkAccessManager();
    m_fileDownloader=new QNetworkAccessManager();
    m_file=NULL;
    connect(ui->btn_showInfo,SIGNAL(clicked(bool)),this,SLOT(btn_show()));
    connect(m_manager,SIGNAL(finished(QNetworkReply*)),this,SLOT(network_reply(QNetworkReply*)));
    connect(m_fileDownloader,SIGNAL(finished(QNetworkReply*)),this,SLOT(downloaded(QNetworkReply*)));
}

zxMain::~zxMain()
{
    delete m_file;
    delete m_fileDownloader;
    delete m_manager;
    delete ui;
}

void zxMain::show_info()
{
    ui->lb_name->setText(m_jsonData["name"].toString());
    ui->lb_phone->setText(m_jsonData["phone"].toString());
    ui->lb_brithday->setText(m_jsonData["brithday"].toString());
    QPixmap avatar;
    if(m_file->isEmpty())
    {
        avatar.load(QString(":/img/user.png"));//load default avatar
    }
    else
    {
        avatar.loadFromData(*m_file);//load user avatar from m_file...
    }
    ui->lb_avatar->setPixmap(avatar);
}

void zxMain::send_request()
{
    QUrl url(QString("http://localhost:8080/Qt-mrzx_ir/server.php"));
    QNetworkRequest req(url);
    req.setHeader(QNetworkRequest::ContentTypeHeader,"application/x-www-form-urlencoded");
    QString body="username="+ui->le_uName->text()+"&password="+ui->le_uPass->text();

    m_manager->post(req,body.toLatin1());
}

void zxMain::send_request(QUrl url)
{
    QNetworkRequest req(url);//url of avatar...
    m_fileDownloader->get(req);
}

void zxMain::btn_show()
{
    ui->btn_showInfo->setEnabled(false);
    send_request();
}

void zxMain::network_reply(QNetworkReply *reply)
{
    if(reply->error()==QNetworkReply::NoError)
    {
        QString data=(QString)reply->readAll();
        QJsonDocument jsonDoc=QJsonDocument::fromJson(data.toUtf8());
        m_jsonData=jsonDoc.object();
        qDebug()<<data;
        if(m_jsonData["error"].toString()=="noError")
           {
            QString name(m_jsonData["name"].toString()),
                    phone(m_jsonData["phone"].toString()),
                    brithday(m_jsonData["brithday"].toString());
            QUrl avatarUrl=m_jsonData["avatar"].toString();
            send_request(avatarUrl);
        }
        else
            QMessageBox::information(this,"خطا","نام کاربری یا کلمه عبور اشتباه می باشد.");
    }
    else
        QMessageBox::information(this,"خطا",reply->errorString());
}

void zxMain::downloaded(QNetworkReply *reply)
{
    if(m_file!=NULL)
    {
        delete m_file;
        m_file=NULL;
    }
   if(reply->error()==QNetworkReply::NoError)
   {
    m_file=new QByteArray(reply->readAll());
   }
    show_info();
    ui->btn_showInfo->setEnabled(true);
}
